#include <SoftwareSerial.h>
#include <Servo.h> 

unsigned char valor;              // Declara un caracte sin la parte negativa
int num; // declara tipo entero 
Servo servo1, servo2, servo3, servo4, servo5, servo6;    // declara servo1, servo2, servo3, servo4, servo5, servo6
char letra;                      // declara una variable tipo caracter

void setup()                     
{
 pinMode(3, OUTPUT);            // Inicializa pin 3 como Salida
 pinMode(5, OUTPUT);            // Inicializa pin 5 como Salida
 pinMode(6, OUTPUT);            // Inicializa pin 6 como Salida
 pinMode(9, OUTPUT);            // Inicializa pin 8 como Salida
 pinMode(10, OUTPUT);           // Inicializa pin 10 como Salida
 pinMode(11, OUTPUT);           // Inicializa pin 11 como Salida


 servo1.attach(3);           // initializa servo1 al pin 3 
 servo2.attach(5);           // initializa servo2 al pin 5
 servo3.attach(6);           // initializa servo3 al pin 6
 servo4.attach(9);           // initializa servo4 al pin 9
 servo5.attach(10);          // initializa servo5 al pin 10
 servo6.attach(11);          // initializa servo6 al pin 11

 Serial.begin(115200);            // Inicia comunicacion serial a 115200bps
} 

void loop() 
{                           // espera datos como "a0" "b180" or "c270"
 if(Serial.available()>0)           // si hay datos disponibles
 {    
  letra = Serial.read();          // lee el primer dato del buffer
  if (letra == 'a')               // si el dato es una 'a'
    {
      while(Serial.available() < 1)     // espera a recibir el siguiente dato
      {
      }  
      valor = Serial.read();          // lee el valor 
      
    
      if(valor > 39 && valor < 110)     //si el valor esta entre los rangos de la resistencia flexible
      {
        valor = map(valor, 45, 80, 75, 135);    // ajusta el valor para el recorrido del servo adecuado a cada dedo
        servo1.write(valor);              // mueve el servo
      } 
    }
    if (letra == 'b')                 // Vuelve a repetir el proceso para los demas datos
    {
      while(Serial.available() < 1) 
      {
      }  
      valor = Serial.read();
      if(valor > 39 && valor < 110)
      {
        valor = map(valor, 45, 95, 75, 158);
        servo2.write(valor);
      } 
    }
    if (letra == 'c')
    {
      while(Serial.available() < 1) 
      {
      }  
      valor = Serial.read(); 
     
      if(valor > 39 && valor < 110)
      {
        valor = map(valor, 40, 95, 52, 135);
        
        servo3.write(valor);
      } 
    }
    if (letra == 'd')
    {
      while(Serial.available() < 1) 
      {
      }  
      valor = Serial.read(); 

      if(valor > 39 && valor < 110)
      {
        valor = map(valor, 50, 90, 40, 122);
        servo4.write(valor);
         Serial.println(valor);
      } 
    }
    if (letra == 'e')
    {
      while(Serial.available() < 1) 
      {
      }  
      valor = Serial.read();
      if(valor > 39 && valor < 110)
      {
        valor = map(valor, 50, 85, 50, 160);
        servo5.write(valor);
      } 
    }
    if (letra == 'f')  //Giroscopio 
    {
      while(Serial.available() < 1) 
      {
      }  
      valor = Serial.read();      
      servo6.write(valor);
     } 
  }
}
    
