#include <SoftwareSerial.h>
int dato;
char datochar;
void setup() 
{
  Serial.begin(9600);  // Inicia la comunicacion serie a 9600bps
}

void loop() 
{
  for(unsigned i=0; i<5; i++)
  {
    dato = analogRead(i);               // Lee el valor del sensor
    dato = map(dato, 0, 1023, 0, 255);    // Convierte el dato a 1 byte
    datochar = dato;                    // Pasa el dato a un tipo char para enviarlo 
    
    if (i == 0)                   // Identifica que sensor lee
    {
      Serial.write('a');         // Escrbe una letra para identificarlo    
      delay(5);                  // Espera para no saturar el buffer de memoria del bluetooth
      Serial.write(dato);        // Escribe el dato correspondiente al sensor
      delay(5);                  // Espera a que de tiempo de mover el motor por la otra placa
    }
    if (i == 1)                   // Vuelve a repetir el mismo proceso para los demas sensores
    {
      Serial.write('b');
      delay(5);
      Serial.write(dato);
      delay(5);
    }
    if (i == 2)
    {
      Serial.write('c');
      delay(5);
      Serial.write(dato);
      delay(5);
    }
    if (i == 3)
    {
      Serial.write('d');
      delay(5);
      Serial.write(dato);
      delay(5);
    }
    if (i == 4)
    {
      Serial.write('e');
      delay(5);
      Serial.write(dato);
      delay(5);
    }
     
  }
}
