#include <SoftwareSerial.h>
#include <Servo.h> 

unsigned char valor;              // Declara un caracte sin la parte negativa
int num; // declara tipo entero 
Servo servo1, servo2;           // declara servo1, servo2, servo3, servo4, servo5
char letra;                      // declara una variable tipo caracter


void setup()                     // Setup Code
{
 pinMode(3, OUTPUT);            // Inicializa pin 3 como Salida
 pinMode(5, OUTPUT);            // Inicializa pin 5 como Salida

 servo1.attach(3);           // initializa servo1 al pin 3 
 servo2.attach(5);           // initializa servo2 al pin 5

 Serial.begin(115200);            // Inicia comunicacion serial a 115200bps
} 


void loop() 
{                           // espera datos como "a0" "b180" or "c270"
 if(Serial.available()>0)           // si hay datos disponibles
 {    
  letra = Serial.read();          // lee el primer dato del buffer
  if (letra == 'a')               // si el dato es una 'a'
    {
      while(Serial.available() < 1)     // espera a recibir el siguiente dato
      {
      } 
      valor = Serial.read();          // lee el valor 
      servo1.write(valor);              // mueve el servo 
    }

    if (letra == 'b')                 // Vuelve a repetir el proceso para los demas datos
    {
      while(Serial.available() < 1) 
      {
      }  
      valor = Serial.read();
      servo2.write(valor);
      
    }
    Serial.println(valor);
 }
}
